package org.processmining.changepatterns.algorithms.modelchanges;

import org.deckfour.xes.classification.XEventClasses;
import org.processmining.changepatterns.algorithms.modelchanges.abstr.ChangePatternAbstr;
import org.processmining.plugins.etm.model.narytree.NAryTree;
import org.processmining.plugins.etm.model.narytree.TreeUtils;
import org.processmining.plugins.etm.model.narytree.conversion.NAryTreeToProcessTree;
import org.processmining.plugins.etm.model.narytree.conversion.ProcessTreeToNAryTree;
import org.processmining.processtree.ProcessTree;

public class RemoveFragment extends ChangePatternAbstr {

	public ProcessTree applyChangePattern(ProcessTree tree, int numberOfActivities) {

		ProcessTreeToNAryTree converter = new ProcessTreeToNAryTree();

		NAryTree naryTree = converter.convert(tree);
		XEventClasses classes = converter.getEventClasses();

		/**
		 * Removes a given number of leafs (i.e., activities) from the tree
		 */
		for (int i = 0; i < numberOfActivities; i++)
			naryTree = naryTree.remove(getRandomLeafIndex(naryTree));

		/**
		 * normalizes the tree (removes nodes with 1 child)	
		 */
		NAryTreeToProcessTree converter2 = new NAryTreeToProcessTree();
		return converter2.convert(TreeUtils.normalize(naryTree), classes); 
	}
	
	

}
