package org.processmining.changepatterns.algorithms.modelchanges;

import org.deckfour.xes.classification.XEventClasses;
import org.processmining.changepatterns.algorithms.modelchanges.abstr.ChangePatternAbstr;
import org.processmining.plugins.etm.model.narytree.NAryTree;
import org.processmining.plugins.etm.model.narytree.TreeUtils;
import org.processmining.plugins.etm.model.narytree.conversion.NAryTreeToProcessTree;
import org.processmining.plugins.etm.model.narytree.conversion.ProcessTreeToNAryTree;
import org.processmining.processtree.ProcessTree;

public class SwapFragment extends ChangePatternAbstr {

	public ProcessTree applyChangePattern(ProcessTree tree, int numberOfActivities) {

		ProcessTreeToNAryTree converter = new ProcessTreeToNAryTree();

		NAryTree naryTree = converter.convert(tree);
		XEventClasses classes = converter.getEventClasses();

		/**
		 * Swps a given number of leafs (i.e., activities) within the tree
		 */
		for (int i = 0; i < numberOfActivities; i++) {

			/**
			 * Find a two different leafs
			 */
			int index1 = getRandomLeafIndex(naryTree);
			int index2;
			do index2 = getRandomLeafIndex(naryTree); while (index1 == index2);

			/**
			 * swap them
			 */
			naryTree = naryTree.swap(index1, index2);
		}

		/**
		 * normalizes the tree (removes nodes with 1 child)
		 */
		NAryTreeToProcessTree converter2 = new NAryTreeToProcessTree();
		return converter2.convert(TreeUtils.normalize(naryTree), classes);
	}

}
